set pitch 64.0
set press 64.0
set cont1 0.0
set cont2 64.0
set cont4 64.0
set cont11 127.0
set reverb 10.0
set outID "stdout"
set commtype "stdout"

# Bind an X windows "close" event with the Exit routine
bind . <Destroy> +myExit

proc myExit {} {
    global outID
    puts $outID [format "NoteOff          0.0 1 60 127"]
    flush $outID
    puts $outID [format "ExitProgram"]
    flush $outID
    close $outID
    exit
}

proc noteOn {pitchVal pressVal} {
    global outID
    puts $outID [format "NoteOn           0.0 1 %f %f" $pitchVal $pressVal]
    flush $outID
}

proc noteOff {pitchVal pressVal} {
    global outID
    puts $outID [format "NoteOff          0.0 1 %f %f" $pitchVal $pressVal]
    flush $outID
}

proc printWhatz {tag value1 value2 } {
    global outID
    puts $outID [format "%s %i %f" $tag $value1 $value2]
    flush $outID
}

proc changePress {value} {
    global press
    global outID
    set press $value
    puts $outID [format "AfterTouch       0.0 1 %f" $press]
    flush $outID
}

proc changePitch {value} {
    global pitch
    global outID
    set pitch $value     
    puts $outID [format "PitchBend        0.0 1 %f" $pitch]
    flush $outID
}

scale .bPressure -from 0 -to 128 -length 300 \
-command {changePress } -variable press \
-orient horizontal -label "Strike Vigor" \
-tickinterval 32 -showvalue true -bg grey66

scale .pitch -from 0 -to 128 -length 300 \
-command {changePitch }  -variable pitch \
-orient horizontal -label "MIDI Note Number" \
-tickinterval 32 -showvalue true -bg grey66

scale .cont1 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 2} \
-orient horizontal -label "Stick Hardness" \
-tickinterval 32 -showvalue true -bg grey66 \
-variable cont2

scale .cont2 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 4} \
-orient horizontal -label "Strike Position" \
-tickinterval 32 -showvalue true -bg grey66 \
-variable cont4

#  scale .cont3 -from 0 -to 128 -length 300 \
#  -command {printWhatz "ControlChange    0.0 1 " 11} \
#  -orient horizontal -label "Preset" \
#  -tickinterval 32 -showvalue true -bg grey66 \
#   -variable cont11

scale .vibrato -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 1} \
-orient horizontal -label "Direct Stick" \
-tickinterval 32 -showvalue true -bg grey66\
-variable cont1

scale .reverb -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 44} \
-orient horizontal -label "Reverb" \
-tickinterval 32 -showvalue true -bg grey66  \
-variable reverb  

. config -bg grey20

frame .modal -bg black
frame .modal2 -bg black

radiobutton .modal.0 -text Marimba -bg grey66  \
-command {printWhatz "ControlChange    0.0 1 " 16 0}
radiobutton .modal.1 -text Agogo -bg grey66  \
-command {printWhatz "ControlChange    0.0 1 " 16 16}
radiobutton .modal.2 -text Wood1   -bg grey66  \
-command {printWhatz "ControlChange    0.0 1 " 16 32}
radiobutton .modal.3 -text Reso      -bg grey66 \
-command {printWhatz "ControlChange    0.0 1 " 16 48}
radiobutton .modal2.4 -text Wood2 -bg grey66 \
-command {printWhatz "ControlChange    0.0 1 " 16 64}
radiobutton .modal2.5 -text Beats -bg grey66 \
-command {printWhatz "ControlChange    0.0 1 " 16 80}
radiobutton .modal2.6 -text 2Fix -bg grey66 \
-command {printWhatz "ControlChange    0.0 1 " 16 96}
radiobutton .modal2.7 -text Clump -bg grey66 \
-command {printWhatz "ControlChange    0.0 1 " 16 112}

pack .modal.0 -side left -padx 5
pack .modal.1 -side left -padx 5 -pady 10
pack .modal.2 -side left -padx 5 -pady 10
pack .modal.3 -side left -padx 5 -pady 10
pack .modal
pack .modal2.4 -side left -padx 5
pack .modal2.5 -side left -padx 5
pack .modal2.6 -side left -padx 5 -pady 10
pack .modal2.7 -side left -padx 5 -pady 10
pack .modal2

pack .bPressure -padx 30 -pady 10
pack .pitch 	-padx 30 -pady 10
pack .vibrato 	-padx 30 -pady 10
pack .cont1 	-padx 30 -pady 10
pack .cont2 	-padx 30 -pady 10
#   pack .cont3 	-padx 30 -pady 10
pack .reverb 	-padx 10 -pady 10

frame .noteOn -bg black

button .noteOn.on -text NoteOn -bg grey66 -command { noteOn $pitch $press }
button .noteOn.off -text NoteOff -bg grey66 -command { noteOff $pitch 127.0 }
button .noteOn.exit -text "Exit Program" -bg grey66 -command myExit
button .noteOn.poop -text "poop" -bg grey66 \
	-command {printWhatz "ControlChange    0.0 1 " 1024 0}
pack .noteOn.on -side left -padx 5
pack .noteOn.off -side left -padx 5
pack .noteOn.exit -side left -padx 5
#    pack .noteOn.poop -side left -padx 5	DIAGNOSTIC/VOICING Button


bind all <KeyPress> {
    noteOn $pitch $press 
}

pack .noteOn

  set sockport 2001
  set sockhost localhost
  set err [catch {socket $sockhost $sockport} outID]
