/******************************************/
/*  BowedBar Bar model                       */
/*  by Georg Essl, 1999                   */
/******************************************/

#if !defined(__BowedBar_h)
#define __BowedBar_h

#include "Instrmnt.h"
#include "DLineN.h"
#include "BowTabl.h"
#include "ADSR.h"
//  #include "TwoPole.h"
// #include "WGFilter.h"
#include "BiQuad.h"

//  #define HARD_BP


class BowedBar : public Instrmnt
{
protected:     
  BowTabl *bowTabl;
  ADSR *adsr;
//  #ifndef HARD_BP
//     TwoPole *bandpass_;
  BiQuad *bandpass_;
//    WGFilter *bandpass_;
//  #endif
  
  MY_FLOAT maxVelocity;
  
  MY_FLOAT modes[4];
  DLineN delay[4];
//  #ifdef HARD_BP
  MY_FLOAT Zs[4][2];
  MY_FLOAT coeffs[4][2];
  MY_FLOAT filtOut[4];
  MY_FLOAT filtIn[4];
  MY_FLOAT filtGain[4];
//  #endif
  MY_FLOAT freq;
  int length;
  MY_FLOAT R;
  MY_FLOAT GAIN;
  MY_FLOAT gains[4];
  
  MY_FLOAT slope;
  
  MY_FLOAT velinput;
  
//   float hairnoise;
  MY_FLOAT integration_const_;
  int trackVel;
  MY_FLOAT bowvel, bowTarg, bowPos, lastBowPos;
  
  int pluck_;
public:
  BowedBar(MY_FLOAT lowestFreq);
  ~BowedBar();
  void tuneBandPasses();
  void clear();
  void startBowing(MY_FLOAT amplitude,MY_FLOAT rate);
  void stopBowing(MY_FLOAT rate);
  void pluck(MY_FLOAT amp);
  void setStrikePosition(MY_FLOAT position);
  virtual void noteOn(MY_FLOAT freq, MY_FLOAT amp);
  virtual void noteOff(MY_FLOAT amp);
  virtual void setFreq(MY_FLOAT frequency);
  //     void setVibrato(MY_FLOAT amount);
  virtual void controlChange(int number, MY_FLOAT value);
  virtual MY_FLOAT tick();
};

#endif

