
# Tcl/Tk GUI for Bill's GaitLab
# by Perry R. Cook

# Set initial control values
set gaitrate    72
set lheel    0
set ltoe     10
set llift    20
set lrwait   50
set rheel    60
set rtoe     70
set rlift    80
set rlwait   100
set lheelGain  0
set ltoeGain   115
set lliftGain  0
set lrwaitGain 0
set rheelGain  0
set rtoeGain   115
set rliftGain  0
set rlwaitGain 0
set cont2 64
set cont4 64 
set cont3 64
set cont1 64
set reverb  5
set patchnum 9
set press 64

set outID "stdout"
set commtype "stdout"

# Configure main window
wm title . "Bill's GaitLab"
wm iconname . "Bill's GaitLab"
. config -bg grey66

frame .banner -bg grey66
frame .banner.left -bg grey66
label .banner.left.walklab -text "Bill's Gait Lab \n by Perry R. Cook" \
            -background black -foreground white -relief groove \
            -width 40 -height 2

# Bind an X windows "close" event with the Exit routine
bind . <Destroy> +myExit

proc myExit {} {
    global outID
    puts $outID [format "ExitProgram"]
    flush $outID
    close $outID
    exit
}

proc patchChange {value} {
    global outID press
    puts $outID [format "NoteOn    0.0 1 %i $press" $value]
    flush $outID
}

proc sendall {} {
    global gaitrate lheel ltoe llift lrwait rheel rtoe rlift rlwait \
                lheelgain ltoegain lliftgain lrwaitgain \
                rheelgain rtoegain rliftgain rlwaitgain \
                cont2 cont4 cont3 cont1 reverb patchnum press

    patchChange $patchnum

    printWhatz "ControlChange    0.0 1 " 601 $gaitrate

    printWhatz "ControlChange    0.0 1 " 701 $lheel
    printWhatz "ControlChange    0.0 1 " 702 $ltoe
    printWhatz "ControlChange    0.0 1 " 703 $llift
    printWhatz "ControlChange    0.0 1 " 704 $lrwait
    printWhatz "ControlChange    0.0 1 " 705 $rheel
    printWhatz "ControlChange    0.0 1 " 706 $rtoe
    printWhatz "ControlChange    0.0 1 " 707 $rlift
    printWhatz "ControlChange    0.0 1 " 708 $rlwait
    printWhatz "ControlChange    0.0 1 " 801 $lheelgain
    printWhatz "ControlChange    0.0 1 " 802 $ltoegain
    printWhatz "ControlChange    0.0 1 " 803 $lliftgain
    printWhatz "ControlChange    0.0 1 " 804 $lrwaitgain
    printWhatz "ControlChange    0.0 1 " 805 $rheelgain
    printWhatz "ControlChange    0.0 1 " 806 $rtoegain
    printWhatz "ControlChange    0.0 1 " 807 $rliftgain
    printWhatz "ControlChange    0.0 1 " 808 $rlwaitgain

    printWhatz "ControlChange    0.0 1 " 1 $cont1
    printWhatz "ControlChange    0.0 1 " 2 $cont2
    printWhatz "ControlChange    0.0 1 " 3 $cont3
    printWhatz "ControlChange    0.0 1 " 4 $cont4
    printWhatz "ControlChange    0.0 1 " 44 $reverb
}

proc womanstik {} {
    global gaitrate lheel ltoe llift lrwait rheel rtoe rlift rlwait \
                lheelgain ltoegain lliftgain lrwaitgain \
                rheelgain rtoegain rliftgain rlwaitgain \
                cont2 cont4 cont3 cont1 reverb patchnum press

    set patchnum 8

    set lheel 0
    set ltoe 10
    set llift 20
    set lrwait 60
    set rheel 64
    set rtoe 74
    set rlift 84
    set rlwait 124

    set lheelgain 0
    set ltoegain 128
    set lliftgain 0
    set lrwaitgain 0
    set rheelgain 0
    set rtoegain 128
    set rliftgain 0
    set rlwaitgain 0

    set cont2 80
    set cont4 30
    set cont3 84
    set cont1 64
    set reverb 2

    set gaitrate 74

    sendall
}

proc manhall {} {
    global gaitrate lheel ltoe llift lrwait rheel rtoe rlift rlwait \
                lheelgain ltoegain lliftgain lrwaitgain \
                rheelgain rtoegain rliftgain rlwaitgain \
                cont2 cont4 cont3 cont1 reverb patchnum press

    set patchnum 9

    set lheel 0
    set ltoe 10
    set llift 20
    set lrwait 60
    set rheel 64
    set rtoe 74
    set rlift 84
    set rlwait 124

    set lheelgain 0
    set ltoegain 128
    set lliftgain 0
    set lrwaitgain 0
    set rheelgain 0
    set rtoegain 128
    set rliftgain 0
    set rlwaitgain 0

    set cont2 21
    set cont4 3
    set cont3 8
    set cont1 10
    set reverb 24

    set gaitrate 65

    sendall
}

proc sasquatch {} {
    global gaitrate lheel ltoe llift lrwait rheel rtoe rlift rlwait \
                lheelgain ltoegain lliftgain lrwaitgain \
                rheelgain rtoegain rliftgain rlwaitgain \
                cont2 cont4 cont3 cont1 reverb patchnum press

    set patchnum 0

    set lheel 0
    set ltoe 5
    set llift 8
    set lrwait 11
    set rheel 13
    set rtoe 26
    set rlift 27
    set rlwait 32

    set lheelgain 0
    set ltoegain 64
    set lliftgain 0
    set lrwaitgain 128
    set rheelgain 0
    set rtoegain 0
    set rliftgain 0
    set rlwaitgain 0

    set cont2 77
    set cont4 128
    set cont3 124
    set cont1 0
    set reverb 5

    set gaitrate 75

    sendall
}

proc noteOff {} { printWhatz "NoteOff 0.0 1 " 64 60 }

proc noteOn {} {
   global patchnum press
   printWhatz "NoteOn 0.0 1 " $patchnum $press
}

proc printWhatz {tag value1 value2 } {
    global gaitrate lheel ltoe llift lrwait rheel rtoe rlift rlwait
    global outID
    puts  $outID [format "%s %i %f" $tag $value1 $value2]
    flush $outID
    if {$rlwait < $rlift} {set rlwait $rlift}
    if {$rlift < $rtoe}  { set rlift $rtoe}
    if {$rtoe < $rheel}  { set rtoe $rheel}
    if {$rheel < $lrwait} { set rheel $lrwait}
    if {$lrwait < $llift} {set lrwait $llift}
    if {$llift < $ltoe}  { set llift $ltoe}
    if {$ltoe < $lheel}   { set ltoe $lheel}
}

frame .banner.butts -bg grey66

button .banner.butts.exit -text "Exit" \
        -bg grey50 -fg black -command {myExit}
button .banner.butts.stop -text "Stop Walk" \
        -bg grey50 -fg black -command {noteOff}
button .banner.butts.walk -text "Start Walk" \
        -bg grey50 -fg black -command {noteOn}
button .banner.butts.man -text "Man in Hallway" \
        -bg grey50 -fg black -command {manhall}
button .banner.butts.woman -text "Woman on Sticks" \
        -bg grey50 -fg black -command {womanstik}
button .banner.butts.sasquatch -text "Sasquatch on Snow" \
        -bg grey50 -fg black -command {sasquatch}

frame .controls -bg grey66
frame .controls.rate -bg grey66
image create photo .bill -file "Billy.gif"
button .controls.rate.bill -image .bill
label .controls.rate.label -text "Walk Rate" \
    -bg grey66 -fg black
frame .controls.feet -bg grey66
frame .controls.gains -bg grey66
frame .controls.butts1 -bg grey66
frame .controls.butts2 -bg grey66
frame .controls.butts3 -bg grey66
frame .controls.synth -bg grey66

scale .controls.rate.rate -from 500 -to 10 -length 400 \
-command {printWhatz "ControlChange    0.0 1 " 601} \
-orient vertical -showvalue true \
-tickinterval 100 -bg grey66 -variable gaitrate

scale .controls.feet.lheel -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 701} \
-label "Left Heel" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable lheel

scale .controls.feet.ltoe -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 702} \
-label "Left Toe" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable ltoe

scale .controls.feet.llift -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 703} \
-label "Left Lift" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable llift

scale .controls.feet.lrwait -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 704} \
-label "Left/Right Wait" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable lrwait

scale .controls.feet.rheel -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 705} \
-label "Right Heel" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable rheel

scale .controls.feet.rtoe -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 706} \
-label "Right Toe" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable rtoe

scale .controls.feet.rlift -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 707} \
-label "Right Lift" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable rlift

scale .controls.feet.rlwait -from 0 -to 128 -length 200 \
-command {printWhatz "ControlChange    0.0 1 " 708} \
-label "Right/Left Wait" -orient horizontal \
-tickinterval 32 -showvalue true -bg grey66  \
-variable rlwait

scale .controls.gains.lheel -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 801} \
-orient vertical -showvalue true -bg grey66  \
-variable lheelGain

scale .controls.gains.ltoe -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 802} \
-orient vertical -showvalue true -bg grey66  \
-variable ltoeGain

scale .controls.gains.llift -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 803} \
-orient vertical -showvalue true -bg grey66  \
-variable lliftgain

scale .controls.gains.lrwait -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 804} \
-orient vertical -showvalue true -bg grey66  \
-variable lrwaitGain

scale .controls.gains.rheel -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 805} \
-orient vertical -showvalue true -bg grey66  \
-variable rheelGain

scale .controls.gains.rtoe -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 806} \
-orient vertical -showvalue true -bg grey66  \
-variable rtoeGain

scale .controls.gains.rlift -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 807} \
-orient vertical -showvalue true -bg grey66  \
-variable rliftGain

scale .controls.gains.rlwait -from 128 -to 0 -length 70 \
-command {printWhatz "ControlChange    0.0 1 " 808} \
-orient vertical -showvalue true -bg grey66  \
-variable rlwaitGain

scale .controls.synth.cont2 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 11} \
-orient horizontal -label "(<--High) System Damping (Low-->)" \
-tickinterval 32 -showvalue true -bg grey66  \
-variable cont2

scale .controls.synth.cont4 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 4} \
-orient horizontal -label "Number of Objects" \
-tickinterval 32 -showvalue true -bg grey66  \
-variable cont4 

scale .controls.synth.cont3 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 3} \
-orient horizontal -label "Resonance Amount (careful!!)" \
-tickinterval 32 -showvalue true -bg grey66  \
-variable cont3 

scale .controls.synth.cont1 -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 1} \
-orient horizontal -label "Resonance Center Freq." \
-tickinterval 32 -showvalue true -bg grey66  \
-variable cont1

scale .controls.synth.reverb -from 0 -to 128 -length 300 \
-command {printWhatz "ControlChange    0.0 1 " 44} \
-orient horizontal -label "Reverb" \
-tickinterval 32 -showvalue true -bg grey66  \
-variable reverb  

# Configure radio buttons
radiobutton .controls.butts1.maraca -text Maraca -bg grey50  -fg black \
       -command { patchChange 0 } -variable patchnum -width 8 \
       -justify left -value 0
radiobutton .controls.butts1.sekere -text Sekere -bg grey50 -fg black \
       -command { patchChange 2 } -variable patchnum -width 8 \
       -justify left -value 2
radiobutton .controls.butts1.cabasa -text Cabasa -bg grey50 -fg black \
       -command { patchChange 1 } -variable patchnum -width 8 \
       -justify left -value 1
radiobutton .controls.butts2.tambourn -text Tambourn -bg grey50 -fg black \
       -command { patchChange 6 } -variable patchnum -width 8 \
       -justify left -value 6
radiobutton .controls.butts2.sleighbl -text Sleighbl -bg grey50 -fg black \
       -command { patchChange 7 } -variable patchnum -width 8 \
       -justify left -value 7
radiobutton .controls.butts2.cokecan -text CokeCan -bg grey50 -fg black \
       -command { patchChange 12 } -variable patchnum -width 8 \
				-justify left -value 12
radiobutton .controls.butts3.stix1 -text Stix1 -bg grey50 -fg black \
       -command { patchChange 8 } -variable patchnum -width 8 \
       -justify left -value 8
radiobutton .controls.butts3.crunch1 -text Crunch1 -bg grey50 -fg black \
       -command { patchChange 9 } -variable patchnum -width 8 \
       -justify left -value 9
radiobutton .controls.butts3.sandpapr -text SandPaper -bg grey50 -fg black \
       -command { patchChange 11 } -variable patchnum -width 8 \
       -justify left -value 11

#  pack .banner.left.billbutt
pack .banner.left.walklab -padx 5 -pady 2
pack .banner.left
pack .banner.butts.exit -side left -padx 2
pack .banner.butts.stop -side left
pack .banner.butts.walk -side left
pack .banner.butts.man -side left -padx 2
pack .banner.butts.woman -side left 
pack .banner.butts.sasquatch -side left -padx 2
pack .banner.butts -padx 5 -pady 2
pack .banner


pack .controls.rate.bill -pady 20
pack .controls.rate.label
pack .controls.rate.rate

pack .controls.feet.lheel    -pady 1
pack .controls.feet.ltoe    -pady 1
pack .controls.feet.llift   -pady 1
pack .controls.feet.lrwait   -pady 1
pack .controls.feet.rheel   -pady 1
pack .controls.feet.rtoe   -pady 1
pack .controls.feet.rlift  -pady 1
pack .controls.feet.rlwait  -pady 1

pack .controls.gains.lheel 
pack .controls.gains.ltoe  
pack .controls.gains.llift
pack .controls.gains.lrwait
pack .controls.gains.rheel   
pack .controls.gains.rtoe   
pack .controls.gains.rlift 
pack .controls.gains.rlwait

pack .controls.butts3.stix1 -side left -padx 5 -pady 2
pack .controls.butts3.crunch1 -side left -padx 5 -pady 2
pack .controls.butts3.sandpapr -side left -padx 5 -pady 2
pack .controls.butts2.tambourn -side left -padx 5 -pady 2
pack .controls.butts2.sleighbl -side left -padx 5 -pady 2
pack .controls.butts2.cokecan -side left -padx 5 -pady 2
pack .controls.butts1.maraca -side left -padx 5 -pady 2
pack .controls.butts1.sekere -side left -padx 5 -pady 2
pack .controls.butts1.cabasa -side left -padx 5 -pady 2

pack .controls.synth.cont2    -padx 5 -pady 20
pack .controls.synth.cont4    -padx 5 -pady 2
pack .controls.synth.cont3    -padx 5 -pady 2
pack .controls.synth.cont1    -padx 5 -pady 2
pack .controls.synth.reverb    -padx 5 -pady 2

pack .controls.rate -side left -padx 5 -pady 2
pack .controls.feet -side left -padx 5 -pady 2
pack .controls.gains -side left -pady 2
pack .controls.synth -side bottom -pady 20
pack .controls.butts1 -side bottom -pady 2
pack .controls.butts2 -side bottom -pady 2
pack .controls.butts3 -side bottom -pady 2
pack .controls -padx 5 -pady 2

patchChange 9

  set sockport 2002
  set sockhost localhost
  set err [catch {socket $sockhost $sockport} outID]


