/*******************************************/
/*  ModalBar SubClass of Modal4 Instrument */
/*  by Perry R. Cook, 1999                 */ 
/*                                         */
/*   Controls:    CONTROL1 = stickHardness */
/*                CONTROL2 = strikePosition*/
/*		  CONTROL3 = Mode Presets  */
/*		  MOD_WHEEL= ??????        */
/*******************************************/

#if !defined(__ModalBar_h)
#define __ModalBar_h

#include "Modal4.h"
#include "OnePole.h"
#include "Noise.h"

class ModalBar : public Modal4
{
  private:
	  Noise noise;
	  OnePole inputFilt;
	  MY_FLOAT gains[4];
  public:
    ModalBar();
    ~ModalBar();
    void setStickHardness(MY_FLOAT hardness);
    void setStrikePosition(MY_FLOAT position);
    void setModalPreset(int which);
	void setModalParam(int whichFilt,MY_FLOAT ratio,MY_FLOAT reson,MY_FLOAT gain);
    void metaControl(int number, char *valString);
    void setModulationDepth(MY_FLOAT mDepth);
    virtual void controlChange(int number, MY_FLOAT value);
};

#endif
