/**********************************************/
/**    Utility to make various flavors of    **/
/**    sine wave (rectified, etc), and       **/
/**    other commonly needed waveforms, like **/
/**    triangles, ramps, etc.                **/
/**    The files generated are all 16 bit    **/
/**    linear signed integer, of length      **/
/**    as defined by LENGTH below            **/
/**********************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define LENGTH 256
#define PI 3.14159265358979323846

void main()
{
    int i,j;
    double temp,temp2;
    short data[LENGTH + 2];
    FILE *fd;


    fd = fopen("impuls80.raw","wb");
    for (i=0;i<LENGTH;i++)      {
        temp = 0.0;
        for (j=1;j<=80;j++)   {
            temp2 = cos(i * j * 2 * PI / (double) LENGTH);
            temp += temp2;
        }
        data[i] = 32767 / 80.0 * temp;
    }
    fwrite(&data,2,LENGTH,fd);
    fclose(fd);

}
